// Battle Arena
//
// Created by Jimomighty

//------------------------------------------------------------------------------
// Specify this when editing Map File (Don't want to execute script)
//------------------------------------------------------------------------------
if($OFFLINE_NAV_BUILD)
   return;

//------------------------------------------------------------------------------
// Version
//------------------------------------------------------------------------------
$SPM_Version_BattleArena = 02.00;

//------------------------------------------------------------------------------
// Variables
//------------------------------------------------------------------------------
// Make sure timescale is 1.
$timescale = 1;
$started = 0;
$player.bot = 0;

// Getting users old values.
$MPRestoreSpaceValue = movemap.getcommand(keyboard, space);
$MPRestoreMusic = $pref::Audio::musicEnabled;
$MPRestoreTriconScript = $Tricon::DisableScriptAnnounce;
$MPRestoreTriconMOTD = $Tricon::MOTDDisable;
$MPRestoreTriconNotify = $Tricon::NotifyClanmatesOnJoin;

// We are going to user the space key to start the mission.
moveMap.bind(keyboard, "space", togglePause);

// Disable music for now.
$pref::Audio::musicEnabled = 0;

//------------------------------------------------------------------------------
// Execute Scripts.
//------------------------------------------------------------------------------
exec("scripts/BattleArena_Variable.cs");
exec("scripts/BattleArena_Datablock.cs");
exec("scripts/BattleArena_Text.cs");
if ($SPM_Addonpack_BattleArena)
	exec("scripts/BattleArena_Music.cs");
exec("scripts/BattleArena_Function.cs");
exec("scripts/BattleArena_Mission.cs");

//------------------------------------------------------------------------------
// Activate our Battle Arena Packages
//------------------------------------------------------------------------------
function ba_activatePackages() {
	activatePackage(BattleArena_Variable);
	//activatePackage(BattleArena_Datablock);
	activatePackage(BattleArena_Text);
	if ($SPM_Addonpack_BattleArena)
		activatePackage(BattleArena_Music);
	activatePackage(BattleArena_Function);
	activatePackage(BattleArena_Mission);
}

//------------------------------------------------------------------------------
// Deactivate our Battle Arena Packages
//------------------------------------------------------------------------------
function ba_deactivatePackages() {
	deactivatePackage(BattleArena_Variable);
	//deactivatePackage(BattleArena_Datablock);
	deactivatePackage(BattleArena_Text);
	if ($SPM_Addonpack_BattleArena)
		deactivatePackage(BattleArena_Music);
	deactivatePackage(BattleArena_Function);
	deactivatePackage(BattleArena_Mission);
}

// Cue the music!
ba_activatePackages();