// Battle Arena
//
// Created by Jimomighty

// This file we specify function that are used for mission.

//------------------------------------------------------------------------------
// Here we initialize the next fight OR when user dies, add the effect.
//  -We have to put this function outside of the package.
//------------------------------------------------------------------------------
function SinglePlayerGame::onClientKilled(%game, %clVictim, %clKiller, %damageType, %implement)
{
	if(game.missionOver)
		return;

	%clVictim.dead = true;

	Parent::onClientKilled(%game, %clVictim, %clKiller, %damageType, %implement);
	cancel(%clVictim.respawnTimer);

   if(%clvictim != $player) {
   	$player.lives = 0;

   	schedule(1000, 0, "tier_next_fight");

   	return;
	}

	%number = GetRandom(1, 2);
   switch (%number) {
		case 1:
			alxPlay(Loss1, 0, 0, 0);
		case 2:
			alxPlay(Loss2, 0, 0, 0);
	}

	cancel($player.OOB);
	if ($SPM_Addonpack_BattleArena) {
		MusicPlayer.stop();
		$player.game_music = "death";
		MusicPlayer.play();
	}
	$timescale = 0.2;
	
	schedule(5000, 0, "death_ending");
}

//------------------------------------------------------------------------------
// Battle Arena Function Package Starts
//------------------------------------------------------------------------------
package BattleArena_Function {

//------------------------------------------------------------------------------
// Death Ending Stuff
//------------------------------------------------------------------------------
function death_ending() {
	if (ClientGroup.getCount()) // Hack
		messageBoxOk("Failed", "You have died.", "$timescale = 1;MusicPlayer.stop();PacifistMap1.pop();clearQueue();disconnect();ba_deactivatePackages();");
}

//------------------------------------------------------------------------------
// Disable Score Screen
//------------------------------------------------------------------------------
function toggleScoreScreen(%val) {
}

//------------------------------------------------------------------------------
// Disable Command Circut
//------------------------------------------------------------------------------
function toggleCommanderMap(%val) {
}

//------------------------------------------------------------------------------
// Disable Network Display
//------------------------------------------------------------------------------
function toggleNetDisplayHud( %val ) {
}

//------------------------------------------------------------------------------
// Disable Voice Capture
//------------------------------------------------------------------------------
function voiceCapture( %val ) {
}

//------------------------------------------------------------------------------
// When player return from game from the menu. (UnPause)
//------------------------------------------------------------------------------
function SinglePlayerEscapeDlg::returnToGame( %this ) {
	parent::returnToGame( %this );
}

//------------------------------------------------------------------------------
// Mission is done loading.
//------------------------------------------------------------------------------
function SinglePlayerGame::missionLoadDone(%game) {
   Parent::missionLoadDone(%game);
   BattleArenaPreloads();
}

//------------------------------------------------------------------------------
// Preloading Images.
//------------------------------------------------------------------------------
function BattleArenaPreloads() {
   navGraph.preload("skins/base.lbioderm", true);
   navGraph.preload("skins/base.lbioderm_512", true);
   navGraph.preload("skins/base.mbioderm", true);
   navGraph.preload("skins/base.mbioderm_512", true);
   navGraph.preload("skins/base.hbioderm", true);
   navGraph.preload("skins/base.hbioderm_512", true);
   navGraph.preload("skins/swolf.lmale", false);
   navGraph.preload("skins/swolf.mmale", false);
   navGraph.preload("skins/swolf.hmale", false);
}

//------------------------------------------------------------------------------
// When client sets hud.
//------------------------------------------------------------------------------
function ClientCmdSetHudMode(%mode, %type, %node) {
   parent::ClientCmdSetHudMode(%mode, %type, %node);
}

//------------------------------------------------------------------------------
// Set a waypoint to a player.
//------------------------------------------------------------------------------
function player_waypoint (%client, %clTarget) {
   if (!AIClientIsAlive(%clTarget))
      return;

   %client.setTargetId(%clTarget.target);
   commandToClient(%client, 'TaskInfo', %client, -1, false, "Attack Enemy");
   %client.sendTargetTo(%client, true);

	schedule(game.waypointDuration, 0, "removeClientTargetType", $player, "AssignedTask");
}

//------------------------------------------------------------------------------
// Set players armor.
//------------------------------------------------------------------------------
function Player::setArmor(%this,%size)
{
   // Takes size as "Light","Medium", "Heavy"
   %client = %this.client;
   if (%client.race $= "Bioderm")
      // Only have male bioderms.
      %armor = %size @ "Male" @ %client.race @ Armor;
   else
      %armor = %size @ %client.sex @ %client.race @ Armor;

   %this.setDataBlock(%armor);
   %client.armor = %size;
}

//------------------------------------------------------------------------------
// Equip the player with desired Inventory
//------------------------------------------------------------------------------
function SinglePlayerGame::equip(%game, %player) {
	// Clear Player Inventory
   %player.clearInventory();
   
   for(%i =0; %i<$InventoryHudCount; %i++)
   	%player.client.setInventoryHudItem($InventoryHudData[%i, itemDataName], 0, 1);
   %player.client.clearBackpackIcon();

   %client = %player.client;
	if (%client.isAIControlled()) {
		%val = $player.player.getArmorsize();
		if (%val $= "Heavy") {
			%set = 3;
		} else if (%val $= "Medium") {
			%set = 2;
		} else {
			%set = 1;
		}

	   switch (%set) {
		   case 1:
		      %player.setArmor("Light");
		      
		      %player.setInventory(EnergyPack, 1);
		      
		      %player.setInventory(RepairKit,1);
		      %player.setInventory(Grenade,3);
		      
				%player.setInventory(GrenadeLauncher, 1);
				%player.setInventory(GrenadeLauncherAmmo, 30);
		      %player.setInventory(Disc,1);
		      %player.setInventory(Chaingun, 1);
		      %player.setInventory(ChaingunAmmo, 100);
		      %player.setInventory(DiscAmmo, 20);
		      %player.weaponCount = 3;

		   case 2:
		      %player.setArmor("Medium");
		
		      %player.setInventory(EnergyPack, 1);
		
		      %player.setInventory(RepairKit, 1);
		      %player.setInventory(Grenade, 6);
		
				%player.setInventory(Chaingun, 1);
				%player.setInventory(ChaingunAmmo, 150);
		      %player.setInventory(Disc,1);
		      %player.setInventory(DiscAmmo, 15);
		      %player.setInventory(Plasma, 1);
		      %player.setInventory(PlasmaAmmo, 40);
				%player.setInventory(GrenadeLauncher, 1);
				%player.setInventory(GrenadeLauncherAmmo, 12);
		      %player.setInventory(TargetingLaser, 1);
		      %player.weaponCount = 4;

		   case 3:
			   %player.setArmor("Heavy");
		      %player.setInventory(EnergyPack, 1);
		
		      %player.setInventory(RepairKit, 2);
		      %player.setInventory(Grenade, 18);
		
		      %player.setInventory(Plasma, 1);
		      %player.setInventory(PlasmaAmmo, 80);
				%player.setInventory(Mortar, 1);
				%player.setInventory(MortarAmmo, 20);
				%player.setInventory(GrenadeLauncher, 1);
				%player.setInventory(GrenadeLauncherAmmo, 30);
		      %player.setInventory(Disc,1);
		      %player.setInventory(DiscAmmo, 30);
		      %player.setInventory(MissileLauncher,1);
		      %player.setInventory(MissileLauncherAmmo, 12);
		      %player.setInventory(TargetingLaser, 1);
		      %player.weaponCount = 5;
		      
		      %player.use(Mortar);
		}
		return;
	}
   
   %size = $NameToInv[%client.favorites[0]];
   if (%client.race $= "Bioderm")
      %armor = %size @ "Male" @ %client.race @ Armor;
   else
      %armor = %size @ %client.sex @ %client.race @ Armor;
   if (!(isObject(%armor)))
      %game.equip(%player);
   else
   {
      for(%i =0; %i<$InventoryHudCount; %i++)
         %client.setInventoryHudItem($InventoryHudData[%i, itemDataName], 0, 1);
      buyFavorites(%client);   
      if (%client.player.weaponCount > 0)
         %player.selectWeaponSlot( 0 );
   }
}

//------------------------------------------------------------------------------
// Turn's the player to an AI
//------------------------------------------------------------------------------
function turnPlayerToAI(%obj) {
   %vec = VectorSub($player.player.position, %obj.player.position);
   %angle = mATan( getWord(%vec, 0), getWord(%vec, 1) );
   %angle = %angle + 3.141529;
   %newTransform = $player.player.position SPC "0 0 1" SPC %angle;
   $player.player.setTransform(%newTransform);
}

//------------------------------------------------------------------------------
// Disable Keys.
//------------------------------------------------------------------------------
function getPacifistMap1() {
   new ActionMap(PacifistMap1);

   PacifistMap1.blockBind( moveMap, jump );
   PacifistMap1.blockBind( moveMap, mouseFire );
   PacifistMap1.blockBind( moveMap, suicide );
   PacifistMap1.blockBind( moveMap, mouseJet );
   PacifistMap1.blockBind( moveMap, throwGrenade );
   PacifistMap1.blockBind( moveMap, placeMine );
   PacifistMap1.blockBind( moveMap, placeBeacon );
   PacifistMap1.blockBind( moveMap, useRepairKit );
   PacifistMap1.blockBind( moveMap, useTargetingLaser );
   PacifistMap1.blockBind( moveMap, throwWeapon );
   PacifistMap1.blockBind( moveMap, throwPack );
}

//------------------------------------------------------------------------------
// We own all AI's, you do what they want them to do.
//------------------------------------------------------------------------------
function serverCmdBuildClientTask(%client, %task, %team) {
	parent::serverCmdBuildClientTask(%client, %task, %team);
}

//------------------------------------------------------------------------------
// Spawn the Player
//------------------------------------------------------------------------------
function spawnSinglePlayer() {
   parent::spawnSinglePlayer();
}

//------------------------------------------------------------------------------
// Don't give AI's default tasks when they respawn.
//------------------------------------------------------------------------------
function singlePlayerGame::onAIRespawn(%game, %client) {
}

//------------------------------------------------------------------------------
// Only for Deving purposes, ... :D
//------------------------------------------------------------------------------
function cheat() {
	$player.player.setinvincible(true);
	$player.player.applyrepair(1);
}


//------------------------------------------------------------------------------
// When Playing GUI is loaded.
//------------------------------------------------------------------------------
function PlayGui::onWake(%this) {
   parent::onWake(%this);
}

//------------------------------------------------------------------------------
// When AI mountes.
//------------------------------------------------------------------------------
function Armor::AIonMount(%this, %obj, %vehicle, %node) {
}

//------------------------------------------------------------------------------
// When AI unmountes.
//------------------------------------------------------------------------------
function Armor::AIonUnMount(%this, %obj, %vehicle, %node) {
}

//------------------------------------------------------------------------------
// Schedule a function call when user leaves mission.
//------------------------------------------------------------------------------
function singleplayerGame::leaveMissionArea(%game, %playerData, %player)
{
   if(%player.getState() $= "Dead")
      return;
   
   %player.client.outOfBounds = true;
   messageClient(%player.client, 'LeaveMissionArea', '\c1You left the mission area.~wfx/misc/warning_beep.wav');
   
   if(%player.client != $player)
      return;
   
   messageClient(%player.client, 'LeaveMissionArea', '\c1You have 10 seconds to re-enter playing field.');

	%id = getRandom();
	$player.mission_over_id = %id;
   schedule(10000, $player, "check_mission_over", %id);
}

//------------------------------------------------------------------------------
// Remove Mission Over ID
//------------------------------------------------------------------------------
function DefaultGame::enterMissionArea(%game, %playerData, %player)
{
   if(%player.getState() $= "Dead")
      return;
   
   %player.client.outOfBounds = false;
   $player.mission_over_id = 0;

   messageClient(%player.client, 'EnterMissionArea', '\c1You are back in the mission area.');
}

//------------------------------------------------------------------------------
// Is the user back on track?
//------------------------------------------------------------------------------
function check_mission_over(%id) {	
	if ($player.mission_over_id == %id) {
		$timeScale = 1;
		MusicPlayer.stop();
		PacifistMap1.pop();
		clearQueue();
		missionFailed("You have to stay inbounds! Try again?");
	}
}

//------------------------------------------------------------------------------
// Pauses the game.
//------------------------------------------------------------------------------
function togglePause()
{
	if ($started)
		return;
	
	$started = 1;
	$pref::Audio::musicEnabled = $MPRestoreMusic;
	moveMap.bind(keyboard, "space", $MPRestoreSpaceValue);
	beginBattleArenaIntroStage2();
}

//------------------------------------------------------------------------------
// Remove unwanted items.
//------------------------------------------------------------------------------
function cleanupfornext()
{
	%this = nameToID("MissionCleanup");
   %count = %this.getCount();
   // have to do this backwards or only half the objects will be deleted
   for(%i = (%count - 1); %i > -1; %i--)
   {
      %detritus = %this.getObject(%i);

      if(%detritus.getClassName() $= "SimSet")
      {
      }
      else if (%detritus.getClassName() $= "Camera")
      {
      }
      else if (%detritus.getClassName() $= "SimGroup")
      {
      }
      else if (%detritus.getClassName() $= "Player")
      {
      }
      else if(%detritus.getName() $= "PZones")
      {
      }
      else if(%detritus.getName() $= PosMarker)
      {
      }
      else if((%detritus.getName() $= "TeamDrops1") || (%detritus.getName() $= "TeamDrops2"))
      {
      }
      else if (%detritus.getName() $= "PlayerListGroup")
      {
      }
      else if (%detritus.getDatablock().getName() $= "stationTrigger")
      {
      }
      else if (%detritus.getDatablock().getName() $= "StationVehicle")
      {
      }
      else
      {
         // this group of stuff to be deleted should include:
         // mines, deployed objects, projectiles, explosions, corpses,
         // players, and the like.
         %detritus.delete();
      }
   }
}

};
//------------------------------------------------------------------------------
// Battle Arena Function Package Ends
//------------------------------------------------------------------------------