// Battle Arena
//
// Created by Jimomighty

// This file we specify code directly related to what is happening in mission.

//------------------------------------------------------------------------------
// Battle Arena Mission Package Starts
//------------------------------------------------------------------------------
package BattleArena_Mission {

//------------------------------------------------------------------------------
// Start the Mission
//------------------------------------------------------------------------------
function startCurrentMission() {
   getPacifistMap1();
	PacifistMap1.pop();

	playGui.add(outerChatHud);

   // Enable Settings Button
   SinglePlayerEscSettingsBtn.setActive(1);

	// Update Objective Hud
	updateTrainingObjectiveHud(BA_301);
	
	// Player Variables
	$player.lives = 3;

	// Make Sure!
	trace(0);

	beginBattleArenaIntroStage1();
}

//------------------------------------------------------------------------------
// When the player spawns make sure all AI attack if suppose to.
//------------------------------------------------------------------------------
function singlePlayerGame::playerSpawned(%game, %player) {
   parent::playerSpawned(%game, %player);
}

//------------------------------------------------------------------------------
// Setup player, let them pick loadout.
//------------------------------------------------------------------------------
function beginBattleArenaIntroStage1() {
	// Play the Music
	if ($SPM_Addonpack_BattleArena)
		MusicPlayer.play();

   // Intro Bools
   $Camera::movementSpeed = 0;
	$AIDisableChatResponse = true;
	$Tricon::DisableScriptAnnounce = 1;
	$Tricon::MOTDDisable = 1;
	$Tricon::NotifyClanmatesOnJoin = 0;
	$enemyTeam = 2;

   $player.player.setTransform(nametoid(Spawn_Start).position);
   $player.player.setmovestate(true);
   PacifistMap1.push();

	BottomPrintAll("Please choose your desired loadout in your Inventory HUD.\n\nUpon doing so, press SPACE to continue the mission.", 0, 3 );
}

//------------------------------------------------------------------------------
// We are about to start.
//------------------------------------------------------------------------------
function beginBattleArenaIntroStage2() {
	$timeScale = 1;
	if ($SPM_Addonpack_BattleArena)
		$pref::Audio::musicEnabled = 1;

   $player.player.setmovestate(false);
	game.equip($player.player);
	$player.player.applyRepair(1);

   // Third Person
   if($firstperson)
      toggleFirstPerson($player);

	ClearBottomPrintAll();

   doText(BA_401);

   PacifistMap1.pop();

   tier_next();
}

//------------------------------------------------------------------------------
// Get next Tier
//------------------------------------------------------------------------------
function tier_next() {
	ClearBottomPrintAll();

	if (!$pref::ba_tier || $pref::ba_tier > 12)
		$pref::ba_tier = 1;

	%datablock = "Team" @ $pref::ba_tier;
	alxPlay(%datablock, 0, 0, 0);

	objectiveHud.spText[2].setValue("Current Level :" @ $pref::ba_tier);

   switch ($pref::ba_tier) {
		case 1:
   		tier_one();
		case 2:
   		tier_two();
		case 3:
   		tier_three();
		case 4:
   		tier_four();
		case 5:
   		tier_five();
		case 6:
   		tier_six();
		case 7:
   		tier_seven();
		case 8:
   		tier_eight();
		case 9:
   		tier_nine();
		case 10:
   		tier_ten();
		case 11:
   		tier_extreme();
		case 12:
   		tier_bonus();
	}
}

//------------------------------------------------------------------------------
// Tier 01
//------------------------------------------------------------------------------
function tier_one() {
	if ($SPM_Addonpack_BattleArena) {
		MusicPlayer.stop();
		$player.game_music = "battle_01";
		MusicPlayer.play();
	}

	$tier_id = 0;
	$tier_count = 30;

	schedule(3000, 0, "tier_next_fight");
}

//------------------------------------------------------------------------------
// Tier 02
//------------------------------------------------------------------------------
function tier_two() {
	if ($SPM_Addonpack_BattleArena) {
		MusicPlayer.stop();
		$player.game_music = "battle_02";
		MusicPlayer.play();
	}

	$tier_id = 0;
	$tier_count = 24;
	
	schedule(3000, 0, "tier_next_fight");
}

//------------------------------------------------------------------------------
// Tier 03
//------------------------------------------------------------------------------
function tier_three() {
	if ($SPM_Addonpack_BattleArena) {
		MusicPlayer.stop();
		$player.game_music = "battle_03";
		MusicPlayer.play();
	}

	$tier_id = 0;
	$tier_count = 20;
	
	schedule(3000, 0, "tier_next_fight");
}

//------------------------------------------------------------------------------
// Tier 04
//------------------------------------------------------------------------------
function tier_four() {
	if ($SPM_Addonpack_BattleArena) {
		MusicPlayer.stop();
		$player.game_music = "battle_04";
		MusicPlayer.play();
	}

	$tier_id = 0;
	$tier_count = 5;
	
	schedule(3000, 0, "tier_next_fight");
}

//------------------------------------------------------------------------------
// Tier 05
//------------------------------------------------------------------------------
function tier_five() {
	if ($SPM_Addonpack_BattleArena) {
		MusicPlayer.stop();
		$player.game_music = "battle_05";
		MusicPlayer.play();
	}

	$tier_id = 0;
	$tier_count = 33;
	
	schedule(3000, 0, "tier_next_fight");
}

//------------------------------------------------------------------------------
// Tier 06
//------------------------------------------------------------------------------
function tier_six() {
	if ($SPM_Addonpack_BattleArena) {
		MusicPlayer.stop();
		$player.game_music = "battle_06";
		MusicPlayer.play();
	}

	$tier_id = 0;
	$tier_count = 33;
	
	schedule(3000, 0, "tier_next_fight");
}

//------------------------------------------------------------------------------
// Tier 07
//------------------------------------------------------------------------------
function tier_seven() {
	if ($SPM_Addonpack_BattleArena) {
		MusicPlayer.stop();
		$player.game_music = "battle_07";
		MusicPlayer.play();
	}

	$tier_id = 0;
	$tier_count = 26;
	
	schedule(3000, 0, "tier_next_fight");
}

//------------------------------------------------------------------------------
// Tier 08
//------------------------------------------------------------------------------
function tier_eight() {
	if ($SPM_Addonpack_BattleArena) {
		MusicPlayer.stop();
		$player.game_music = "battle_08";
		MusicPlayer.play();
	}

	$tier_id = 0;
	$tier_count = 15;
	
	schedule(3000, 0, "tier_next_fight");
}

//------------------------------------------------------------------------------
// Tier 09
//------------------------------------------------------------------------------
function tier_nine() {
	if ($SPM_Addonpack_BattleArena) {
		MusicPlayer.stop();
		$player.game_music = "battle_09";
		MusicPlayer.play();
	}

	$tier_id = 0;
	$tier_count = 11;
	
	schedule(3000, 0, "tier_next_fight");
}

//------------------------------------------------------------------------------
// Tier 10
//------------------------------------------------------------------------------
function tier_ten() {
	if ($SPM_Addonpack_BattleArena) {
		MusicPlayer.stop();
		$player.game_music = "battle_10";
		MusicPlayer.play();
	}

	$tier_id = 0;
	$tier_count = 5;
	
	schedule(3000, 0, "tier_next_fight");
}

//------------------------------------------------------------------------------
// Tier Exterme
//------------------------------------------------------------------------------
function tier_extreme() {
	if ($SPM_Addonpack_BattleArena) {
		MusicPlayer.stop();
		$player.game_music = "battle_11";
		MusicPlayer.play();
	}

	$tier_id = 0;
	$tier_count = 1;
	
	schedule(3000, 0, "tier_next_fight");
}

//------------------------------------------------------------------------------
// Tier Bonus
//------------------------------------------------------------------------------
function tier_bonus() {
	if ($SPM_Addonpack_BattleArena) {
		MusicPlayer.stop();
		$player.game_music = "battle_12";
		MusicPlayer.play();
	}

	$tier_id = 0;
	$tier_count = 15;
	
	schedule(3000, 0, "tier_next_fight");
}

//------------------------------------------------------------------------------
// Start the next fight in the tear.
//------------------------------------------------------------------------------
function tier_next_fight() {
	%i = $tier_id++;
	
	if ($tier_id > $tier_count) {
		tier_completed();

		return;
	}

	// Cleanup
	game.clearDeployableMaxes();
   cleanupfornext();

	game.equip($player.player);
	$player.player.applyRepair(1);

   %number = GetRandom(1, 3);
   $player.player.setTransform(nametoid("Spawn_Point_" @ %number @ "_a").position);
   $player.player.setVelocity("0 0 0");

   PacifistMap1.pop();

   if (!$player.bot) {
		$player.bot = aiConnect("Ghost", $enemyTeam, 0.1);
	} else {
   	$player.bot.offense = false;
   	onAIRespawn($player.bot);
	}

	%bot = $player.bot;
	
   switch ($pref::ba_tier) {
		case 1:
			%bot.nameBase = game.level_01[%i];
			%bot.name = addTaggedString( %bot.nameBase );
			%bot.setSkillLevel(0.1);
			objectiveHud.spText[1].setValue("Fighting player :\"" @ game.level_01[%i] @ "\"");
		case 2:
			%bot.nameBase = game.level_02[%i];
			%bot.name = addTaggedString( %bot.nameBase );
			%bot.setSkillLevel(0.2);
			objectiveHud.spText[1].setValue("Fighting player :\"" @ game.level_02[%i] @ "\"");
		case 3:
			%bot.nameBase = game.level_03[%i];
			%bot.name = addTaggedString( %bot.nameBase );
			%bot.setSkillLevel(0.3);
			objectiveHud.spText[1].setValue("Fighting player :\"" @ game.level_03[%i] @ "\"");
		case 4:
			%bot.nameBase = game.level_04[%i];
			%bot.name = addTaggedString( %bot.nameBase );
			%bot.setSkillLevel(0.4);
			objectiveHud.spText[1].setValue("Fighting player :\"" @ game.level_04[%i] @ "\"");
		case 5:
			%bot.nameBase = game.level_05[%i];
			%bot.name = addTaggedString( %bot.nameBase );
			%bot.setSkillLevel(0.5);
			objectiveHud.spText[1].setValue("Fighting player :\"" @ game.level_05[%i] @ "\"");
		case 6:
			%bot.nameBase = game.level_06[%i];
			%bot.name = addTaggedString( %bot.nameBase );
			%bot.setSkillLevel(0.6);
			objectiveHud.spText[1].setValue("Fighting player :\"" @ game.level_06[%i] @ "\"");
		case 7:
			%bot.nameBase = game.level_07[%i];
			%bot.name = addTaggedString( %bot.nameBase );
			%bot.setSkillLevel(0.7);
			objectiveHud.spText[1].setValue("Fighting player :\"" @ game.level_07[%i] @ "\"");
		case 8:
			%bot.nameBase = game.level_08[%i];
			%bot.name = addTaggedString( %bot.nameBase );
			%bot.setSkillLevel(0.8);
			objectiveHud.spText[1].setValue("Fighting player :\"" @ game.level_08[%i] @ "\"");
		case 9:
			%bot.nameBase = game.level_09[%i];
			%bot.name = addTaggedString( %bot.nameBase );
			%bot.setSkillLevel(0.9);
			objectiveHud.spText[1].setValue("Fighting player :\"" @ game.level_09[%i] @ "\"");
		case 10:
			%bot.nameBase = game.level_10[%i];
			%bot.name = addTaggedString( %bot.nameBase );
			%bot.setSkillLevel(1.0);
			objectiveHud.spText[1].setValue("Fighting player :\"" @ game.level_10[%i] @ "\"");
		case 11:
			%bot.nameBase = game.extreme;
			%bot.name = addTaggedString( %bot.nameBase );
			%bot.setSkillLevel(2.0);
			objectiveHud.spText[1].setValue("Fighting player :\"" @ game.extreme @ "\"");
		case 12:
   		%exp = GetRandom(1, 10) / 10;
			%bot.nameBase = game.bonus[%i];
			%bot.name = addTaggedString( %bot.nameBase );
			%bot.setSkillLevel(%exp);
			objectiveHud.spText[1].setValue("Fighting player :\"" @ game.bonus[%i] @ "\"");
   }
   
   %bot.player.scopeToClient($player);
   %bot.player.setTransform(nameToID("Spawn_Point_" @ %number @ "_b").getTransform());
   %bot.race = "Bioderm";
   %bot.voice = "Derm2";
   setTargetSkin(%bot.target, $teamSkin[$enemyTeam]);
   game.equip(%bot.player);

	if ($SPM_Addonpack_BattleArena) {
		%tempid = $pref::ba_tier;
		if (strlen(%tempid) == 1)
			%tempid = "0" @ %tempid;

		%datablock = "Player" @ %tempid @ "_" @ %i;
		alxPlay(%datablock, 0, 0, 0);
	}

	%bot.pressJump();
	%bot.pressJet();
	%bot.stepEngage($player);

	turnPlayerToAI (%bot);
	schedule(500, 0, "player_waypoint", $player, %bot);
}

//------------------------------------------------------------------------------
// When the tier is completed.
//------------------------------------------------------------------------------
function tier_completed() {
   PacifistMap1.push();
	// So there is a use for this.
	cheat();

	if ($SPM_Addonpack_BattleArena) {
		MusicPlayer.stop();
		$player.game_music = "victory";
		MusicPlayer.play();
	}

	%number = GetRandom(1, 4);
   switch (%number) {
		case 1:
			alxPlay(Victory1, 0, 0, 0);
		case 2:
			alxPlay(Victory2, 0, 0, 0);
		case 3:
			alxPlay(Victory3, 0, 0, 0);
		case 4:
			alxPlay(Victory4, 0, 0, 0);
	}

	if ($pref::ba_tier == 12) {
		BottomPrintAll("Bonus Level Completed.\nIf you wish to quit, do it manually.\nPlay any level you want by setting the value $pref::ba_tier to 1-10.", 0, 3 );

		schedule(20000, 0, tier_next);
	} else if ($pref::ba_tier == 11) {
		$pref::ba_tier++;
		export( "$pref::*", "prefs/ClientPrefs.cs", false );

		MessageBoxOK( "Mission Completed", "Victory!\n\nBonus Level Activated", "$timescale = 1;MusicPlayer.stop();PacifistMap1.pop();clearQueue();disconnect();ba_deactivatePackages();");
	} else {
		BottomPrintAll("\nLevel " @ $pref::ba_tier @ " Completed.", 0, 3 );

		$pref::ba_tier++;
		export( "$pref::*", "prefs/ClientPrefs.cs", false );
		
		schedule(20000, 0, tier_next);
	}
}

//------------------------------------------------------------------------------
// Game over man!
//------------------------------------------------------------------------------
function singlePlayerGame::gameOver(%game) {
   $Camera::movementSpeed = 40;
	$AIDisableChatResponse = "";
	$player.game_music = 0;
	$timescale = 1;
	$tier_id = 0;
	$tier_count = 0;

	$Tricon::DisableScriptAnnounce = $MPRestoreTriconScript;
	$Tricon::MOTDDisable = $MPRestoreTriconMOTD;
	$Tricon::MOTDDisable = $MPRestoreTriconNotify;

	moveMap.bind(keyboard, "space", $MPRestoreSpaceValue);

   if(HelpTextGui.isVisible())
      helpTextGui.setVisible(false);

   SinglePlayerEscSettingsBtn.setActive(1);
   PacifistMap1.pop();

   Parent::gameOver();

	ba_deactivatePackages();
}

};
//------------------------------------------------------------------------------
// Battle Arena Mission Package Ends
//------------------------------------------------------------------------------